#!/usr/bin/perl

use DBI;
use DBD::mysql;
use vars qw ( $db );

print << "EOF";

###############################################################

IMPORTANT NOTE:

THIS WILL DELETE ALL SNORT DATA IN YOUR DATABASE!

This script should ONLY be used if your database has grown 
too large to delete through normal channels.

** Press Ctrl+C at any time to abort this script. **

###############################################################

EOF

my @tables_array = ('data','event','icmphdr','tcphdr','udphdr','iphdr','opt');


print "DB USER? [snort] > ";
chomp (my $db_user = <STDIN>);
($db_user) || ($db_user = "snort");
print "DB PASSWORD? > ";
chomp (my $db_password = <STDIN>);
print "DB HOST? [localhost] > ";
chomp (my $db_host  = <STDIN>);
($db_host) || ($db_host = "localhost");
print "DB NAME? [snort] > ";
chomp (my $db_name    = <STDIN>);
($db_name) || ($db_name = "snort");

print << "EOF";

User: $db_user
Password: $db_password
Host: $db_host
Name: $db_name

EOF
print "Is this correct?[y/N] >";

chomp($huh = <STDIN>);
if ($huh!~/y/i){
	die "OK, come back later when you're ready.\n";
}
&connect_to_db || &error("Invalid credentials, please try again.");

print "Are you SURE you want to delete ALL Snort data in this database? (you must TYPE OUT \"yes\" or this script will abort) [yes|NO] > ";

chomp (my $confirmed    = <STDIN>);

die "Script aborting\n" unless ($confirmed=~/^yes$/i);


my $sql_query;
foreach (@tables_array){
	$sql_query = "DELETE FROM $_";
	print "DELETE FROM $_\n";
	$db_ptr = &run_query($sql_query);
}

print "#"x60 . "\n";
print " All Snort data has been removed, \nplease standby while the tables are being optimized...\n\n";

foreach (@tables_array){
	$sql_query = "OPTIMIZE TABLE $_";
	$db_ptr = &run_query($sql_query);
}

print "Optimizations done.\n";
print "#"x60 . "\n\n\n";



#############################################
# Functions
#############################################
sub run_query{
my ($sql_query) = @_;
&connect_to_db();
$q_count++;
print "Running Query $q_count\n";

my $prepared = $db->prepare($sql_query);
if (!$prepared){
        #Then there's an error with the syntax of the query:
        &error("Syntax Error in SQL Query:\n$sql_query\n:\n".$db->errstr);
}
my $dbquery = $prepared->execute();
if (my $error_string = $prepared->errstr){
        &error("$error_string : $sql_query");
}
return $prepared;
}
#####################
sub connect_to_db{
if (!$db || !$db->ping){

# function args override defaults, but error out if neither are there.
 $db_user         ||  &error("No database user specified.");
 $db_password     ||  &error("No database password specified.");
 $db_host         ||  &error("No database host specified.");
 $db_name         ||  &error("No database specified.");

 $db = DBI->connect("dbi:mysql:host=$db_host;database=$db_name", $db_user , $db_password) || &error("Connection Problem! ". $DBI::errstr);

}
return $db;
}
####################
sub error{
my ($le) = @_;
die "$le\n";
}
##################
sub safe_slash{
my ($string_ref) = @_;

$$string_ref=~s/(['\\])/\\$1/g;

}
#################

